﻿using FarPoint.Win.Spread;
using FarPoint.Win.Spread.DrawingSpace;
using FarPoint.Win.Spread.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Spread_NoteEvent
{
    public class FpSpreadEx : FpSpread
    {
        public event EventHandler<NoteClickedEventArgs> NoteClicked;
        protected override void OnMouseDown(MouseEventArgs e)
        {
            SpreadNotesContainer notesContainer = this.ActiveSheet.NotesContainer;
            if (notesContainer.ChildContains(e.Location, false) is FarPoint.Win.Spread.DrawingSpace.Internal.StickyNoteCommentBase cellNote)
            {
                CellRange cr = (CellRange)cellNote.GetType().GetProperty("CellRange").GetValue(cellNote);
                NoteClicked?.Invoke(this,new NoteClickedEventArgs(cr.Row, cr.Column));
            }
            base.OnMouseDown(e);
        }
    }

    public class NoteClickedEventArgs : EventArgs {
        public NoteClickedEventArgs(int row, int col)
        {
            Row = row;
            Column = col;
        }
       public int Row{ get; private set; }
       public int Column { get; private set; }
    }
}
